All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
BinaryNode Class Reference

holds arbitrary binary data More...

`#include <BinaryNode.h>`

Inheritance diagram for BinaryNode:
[legend]
Collaboration diagram for BinaryNode:
[legend]

## Public Member Functions

DLLEXPORT | BinaryNode (void *p=0, qore_size_t size=0)
| creates the object
virtual DLLEXPORT bool | getAsBoolImpl () const
| returns false unless perl-boolean-evaluation is enabled, in which case it returns false only when empty
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, class ExceptionSink *xsink) const
| concatenate the verbose string representation of the value to an existing QoreString
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, class ExceptionSink *xsink) const
| returns a QoreString giving the verbose string representation of the List (including all contained values for container types)
virtual DLLEXPORT class AbstractQoreNode * | realCopy () const
| returns a copy of the object; the caller owns the reference count
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string
virtual DLLLOCAL AbstractQoreNode * | parseInit (LocalVar *oflag, int pflag, int &lvids, const QoreTypeInfo *&typeInfo)
| returns the type information
DLLEXPORT int | compare (const BinaryNode *obj) const
| returns 0 = equal, 1 = not equal
DLLEXPORT qore_size_t | size () const
| returns the number of bytes in the object
DLLEXPORT bool | empty () const
| returns true if empty
DLLEXPORT BinaryNode * | copy () const
| returns a copy of the object
DLLEXPORT const void * | getPtr () const
| returns the pointer to the data
DLLEXPORT void | append (const void *nptr, qore_size_t size)
| resizes the object and appends a copy of the data passed to the object
DLLEXPORT void | append (const BinaryNode *b)
| resizes the object and appends a copy of the data passed to the object
DLLEXPORT void | append (const BinaryNode &b)
| resizes the object and appends a copy of the data passed to the object
DLLEXPORT void | prepend (const void *nptr, qore_size_t size)
| resizes the object and prepends a copy of the data passed to the beginning of the object
DLLEXPORT void * | giveBuffer ()
| returns the data being managed and leaves this object empty
DLLEXPORT int | preallocate (qore_size_t size)
| pre-allocates a buffer of a certain size
DLLEXPORT int | setSize (qore_size_t size)
| sets the buffer size after preallocation
DLLEXPORT void | clear ()
| frees any managed memory and sets the size to 0
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object
DLLEXPORT int | getAsInt () const
| returns the integer value of the object
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object
DLLEXPORT double | getAsFloat () const
| returns the float value of the object
virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns the value of the type converted to a string, default implementation: returns the empty string
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the value of the type to an existing QoreString reference, default implementation does nothing
virtual DLLEXPORT class DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this type (default implementation: returns ZeroDate, del = false)
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of a value to the DateTime reference passed, default implementation does nothing
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not
DLLLOCAL qore_type_t | getType () const
| returns the data type
DLLEXPORT AbstractQoreNode * | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0)
DLLEXPORT AbstractQoreNode * | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument
DLLEXPORT int64 | bigIntEval (ExceptionSink *xsink) const
| evaluates the object and returns a 64-bit integer value
DLLEXPORT int | integerEval (ExceptionSink *xsink) const
| evaluates the object and returns an integer value
DLLEXPORT bool | boolEval (ExceptionSink *xsink) const
| evaluates the object and returns a boolean value
DLLEXPORT double | floatEval (ExceptionSink *xsink) const
| evaluates the object and returns a floating-point value
DLLLOCAL bool | is_value () const
| returns true if the node represents a value
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count
DLLEXPORT void | ref () const
| increments the reference count
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL int | reference_count () const
| gets the reference count
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1
DLLEXPORT void | ROreference () const
| atomically increments the reference count
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count

## Static Public Member Functions

static DLLLOCAL const char * | getStaticTypeName ()
| returns the type name (useful in templates)
static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)

## Protected Member Functions

virtual DLLEXPORT | ~BinaryNode ()
| frees and memory owned by the object
Protected Member Functions inherited from SimpleValueQoreNode
virtual DLLEXPORT AbstractQoreNode * | evalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT AbstractQoreNode * | evalImpl (bool &needs_deref, ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT int64 | bigIntEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT int | integerEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT bool | boolEvalImpl (ExceptionSink *xsink) const
| should never be called for value types
virtual DLLEXPORT double | floatEvalImpl (ExceptionSink *xsink) const
| should never be called for value types

## Additional Inherited Members

Protected Attributes inherited from AbstractQoreNode
qore_type_t | type: 11
| the type of the object
bool | value: 1
| this is true for values, if false then either the type needs evaluation to produce a value or is a parse expression
bool | needs_eval_flag: 1
| if this is true then the type can be evaluated
bool | there_can_be_only_one: 1
| if this is set to true, then reference counting is turned off for objects of this class
bool | custom_reference_handlers: 1
| set to one for objects that need custom reference handlers

## Detailed Description

holds arbitrary binary data

this class is implemented simply as a pointer and a length indicator

## Constructor & Destructor Documentation

DLLEXPORT BinaryNode::BinaryNode | ( | void * | p = `0`,
|  | qore_size_t | size = `0`
| ) |  |

creates the object

Parameters

  p | a pointer to the memory, the BinaryNode object takes over ownership of this pointer
  size | the byte length of the memory

## Member Function Documentation

DLLEXPORT BinaryNode* BinaryNode::copy | ( |  | ) | const

returns a copy of the object

Returns
  a copy of the current object

virtual DLLEXPORT bool BinaryNode::getAsBoolImpl | ( |  | ) | const

virtual

returns false unless perl-boolean-evaluation is enabled, in which case it returns false only when empty

Returns
  false unless perl-boolean-evaluation is enabled, in which case it returns false only when empty

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT int BinaryNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

concatenate the verbose string representation of the value to an existing QoreString

used for n and N printf formatting

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | if an error occurs, the Qore-language exception information will be added here

Returns
  -1 for exception raised, 0 = OK

Implements AbstractQoreNode.

virtual DLLEXPORT QoreString* BinaryNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

returns a QoreString giving the verbose string representation of the List (including all contained values for container types)

used for n and N printf formatting

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | if an error occurs, the Qore-language exception information will be added here NOTE: Use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead of using this function directly

See Also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

DLLEXPORT void* BinaryNode::giveBuffer | ( |  | ) |

returns the data being managed and leaves this object empty

Returns
  the data being managed (leaves this object empty)

Note
  it would be a grevious error to call this function on an object with a reference_count > 1 (i.e. is_unique() is false)

virtual DLLEXPORT bool BinaryNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality

this function does not throw a Qore-language exception with the BinaryNode class

Parameters

  v | the value to compare
  xsink | is not used in this implementation of the function

Implements AbstractQoreNode.

virtual DLLEXPORT bool BinaryNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality

this function does not throw a Qore-language exception with the BinaryNode class

Parameters

  v | the value to compare
  xsink | is not used in this implementation of the function

Implements AbstractQoreNode.

DLLEXPORT int BinaryNode::preallocate | ( | qore_size_t | size | ) |

pre-allocates a buffer of a certain size

This function can be used to write data directly to a new BinaryNode object. This call can be made more than once, subsequent calls will cause realloc() to be called on the buffer which can be used to extend the buffer size.

Parameters

  size | the number of bytes to pre-allocate

Returns
  0 for OK, -1 for error (memory could not be allocated)

virtual DLLEXPORT class AbstractQoreNode* BinaryNode::realCopy | ( |  | ) | const

virtual

returns a copy of the object; the caller owns the reference count

Returns
  a copy of the object; the caller owns the reference count

Implements AbstractQoreNode.

DLLEXPORT int BinaryNode::setSize | ( | qore_size_t | size | ) |

sets the buffer size after preallocation

This function is designed to be used with BinaryNode::preallocate(). The size to be set must be less than the currently allocated size.

Parameters

  size | the size of the BinaryNode to set

Returns
  0 for OK, -1 for error (size > current size)

The documentation for this class was generated from the following file:

- include/qore/BinaryNode.h (5431)